Bug 1535968 - MPI_OFFSET_KIND defined differently than in OpenMPI on 32bit architectures
Summary: MPI_OFFSET_KIND defined differently than in OpenMPI on 32bit architectures
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Fedora
Classification: Fedora
Component: mpich
Version: 28
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Zbigniew Jędrzejewski-Szmek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-ExcludeArch-x86, F-ExcludeArch-x86 F-ExcludeArch-ARM
TreeView+ depends on / blocked
 
Reported: 2018-01-18 11:04 UTC by Dominik 'Rathann' Mierzejewski
Modified: 2018-04-04 08:43 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-04-04 08:43:09 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Github pmodels mpich issues 3002 None None None Never
Red Hat Bugzilla 1535966 unspecified CLOSED MPI_OFFSET_KIND defined differently than in MPICH on 32bit architectures 2019-12-10 09:55:08 UTC

Internal Links: 1535966

Description Dominik 'Rathann' Mierzejewski 2018-01-18 11:04:54 UTC
Description of problem:
MPI_OFFSET_KIND=4 in OpenMPI while it equals 8 in MPICH on 32bit arches. I don't know which is correct, but this difference has caused compilation issues in cp2k-5.1 with MPICH:
[...]
/builddir/build/BUILD/cp2k-5.1/src/mpiwrap/message_passing.F:3588:70:
                                     type_descriptor%type_handle, ierr)
                                                                      1
Error: Type mismatch in argument 'array_of_displacements' at (1); passed INTEGER(8) to INTEGER(4)
[...]

Version-Release number of selected component (if applicable):
openmpi-2.1.1-5.fc28.i686
mpich-3.2.1-2.fc28.i686

How reproducible:
Always

Steps to Reproduce:
1. grep MPI_OFFSET_KIND= mpich-i386/mpif.h mpich-i386/mpiof.h openmpi-i386/mpif-config.h

Actual results:
mpich-i386/mpif.h:       PARAMETER (MPI_OFFSET_KIND=8)
mpich-i386/mpiof.h:      PARAMETER (MPI_OFFSET_KIND=           8)
openmpi-i386/mpif-config.h:      parameter (MPI_OFFSET_KIND=4)

Expected results:
The value should be the same across MPI implementations.

Additional info:
https://lists.cp2k.org/private/cp2k-dev/2018-January/000856.html

Comment 1 Dominik 'Rathann' Mierzejewski 2018-01-18 11:10:44 UTC
For now upstream worked around it by using MPI_ADDRESS_KIND which equals 4 in both OpenMPI and MPICH.

Comment 2 Fedora End Of Life 2018-02-20 15:21:48 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 28 development cycle.
Changing version to '28'.

Comment 3 Dominik 'Rathann' Mierzejewski 2018-02-21 10:54:47 UTC
Reported upstream, too.

Comment 4 Zbigniew Jędrzejewski-Szmek 2018-04-04 08:43:09 UTC
Upstream bug was closed as "it's an opaque handle is because different MPI implementations can define it differently". I'll just go with upstream says.


Note You need to log in before you can comment on or make changes to this bug.